SkillChangerByIakoni = {}
 
SkillChangerByIakoni.name = "SkillChangerByIakoni"
SkillChangerByIakoni.WaitingForSetToEquip = 0
SkillChangerByIakoni.WaitingForWeaponBarToEquip = 0

SkillChangerByIakoni.SkillBarArray = {
	ACTION_BAR_FIRST_NORMAL_SLOT_INDEX + 1, --3
	ACTION_BAR_FIRST_NORMAL_SLOT_INDEX + 2, --4
	ACTION_BAR_FIRST_NORMAL_SLOT_INDEX + 3, --5
	ACTION_BAR_FIRST_NORMAL_SLOT_INDEX + 4, --6
	ACTION_BAR_FIRST_NORMAL_SLOT_INDEX + 5, --7
	ACTION_BAR_ULTIMATE_SLOT_INDEX + 1,		--8
}
SkillChangerByIakoni.SavedBarArray1 = {	1,2,3,4,5,6 }
SkillChangerByIakoni.SavedBarArray2 = {	7,8,9,10,11,12 }

function SkillChangerByIakoni.Initialize()
	SkillChangerByIakoni.savedVariables = ZO_SavedVars:New("SkillChangerByIakoniSavedVariables", 1, nil, {})
	SkillChangerByIakoni.RestorePosition()
	
	local sv = SkillChangerByIakoni.savedVariables
	
	--test for first ever load. initialise vars
	if sv.SelectedSet == nil then
		sv.SelectedSet = 1
			
		SCBI:ClearAnchors()
		SCBI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 700, 500)
		SkillChangerByIakoni.OnIndicatorMoveStop()
	end
	if sv.ArraySetName == nil then sv.ArraySetName = { 1,2,3,4,5,6,7,8,9,10 } end
	if sv.ArraySetIcon == nil then  sv.ArraySetIcon = { 1,1,1,1,1,1,1,1,1,1 } end
	if sv.ArraySetSavedFlag == nil then sv.ArraySetSavedFlag = { 0,0,0,0,0,0,0,0,0,0 } end
	if sv.ArraySet == nil then
		sv.ArraySet = {}
		for i=1, 10 do
			sv.ArraySet[i] = {}
			for _,v in pairs(SkillChangerByIakoni.SavedBarArray1) do
				sv.ArraySet[i][v] = 0
			end
			for _,v in pairs(SkillChangerByIakoni.SavedBarArray2) do
				sv.ArraySet[i][v] = 0
			end
		end
	end
	if sv.ArraySetTexture == nil then
		sv.ArraySetTexture = {}
		for i=1, 10 do
			sv.ArraySetTexture[i] = {}
			for _,v in pairs(SkillChangerByIakoni.SavedBarArray1) do
				sv.ArraySetTexture[i][v] = ""
			end
			for _,v in pairs(SkillChangerByIakoni.SavedBarArray2) do
				sv.ArraySetTexture[i][v] = ""
			end
		end
	end

	SkillChangerByIakoni.InitTextureArrayForSet()

	--init sets
	for i=1, 10 do
		_G["SCBISet"..i]:SetText(sv.ArraySetName[i])
		
		--validation check for icon
		if sv.ArraySetIcon[i] > SkillChangerByIakoni.TextureArrayForSetSize then
			sv.ArraySetIcon[i] = 1
		end
		_G["SCBISet"..i]:SetNormalTexture(SkillChangerByIakoni.TextureArrayForSet[sv.ArraySetIcon[i]])
		_G["SCBISet"..i]:SetPressedTexture(SkillChangerByIakoni.TextureArrayForSet[sv.ArraySetIcon[i]])
		_G["SCBISet"..i]:SetMouseOverTexture(SkillChangerByIakoni.TextureArrayForSet[sv.ArraySetIcon[i]])
	end
	
	local InventoryScene = SCENE_MANAGER.scenes.skills
	--local inventoryScene = SCENE_MANAGER:GetScene("inventory")
	InventoryScene:RegisterCallback("StateChange", function(oldState, newState) 
		-- states: hiding, showing, shown, hidden
		if(newState == "showing") then
			-- do something if the inventory is beginning to show
			SCBI:SetHidden(false)
		elseif(newState == "hiding") then
			-- do something if the inventory is beginning to hide
			SCBI:SetHidden(true)
		end
	end)
	
	--init UI
	SkillChangerByIakoni.SelectSet(sv.SelectedSet)
	SkillChangerByIakoni.UpdateSavedFlags()

	SCBI:SetHidden(true)
end

function SkillChangerByIakoni.ClearSelectSets()
	for i=1, 10 do
		_G["SCBISet"..i.."Select"]:SetHidden(true)
	end
end

function SkillChangerByIakoni.UpdateSavedFlags()
	for i=1, 10 do
		if SkillChangerByIakoni.savedVariables.ArraySetSavedFlag[i] == 1 then
			_G["SCBISet"..i.."Highlight"]:SetHidden(false)
		else
			_G["SCBISet"..i.."Highlight"]:SetHidden(true)
		end
	end
end

function SkillChangerByIakoni.SelectSet(id)
	SkillChangerByIakoni.ClearSelectSets()
	_G["SCBISet"..id.."Select"]:SetHidden(false)
	SkillChangerByIakoni.savedVariables.SelectedSet=id
	
	SCBISetNameEditBox:SetText(SkillChangerByIakoni.savedVariables.ArraySetName[id]);
	
	SkillChangerByIakoni.UpdateSkillTexturesForSelected()
end

function SkillChangerByIakoni.NameTextChanged()
	SkillChangerByIakoni.savedVariables.ArraySetName[SkillChangerByIakoni.savedVariables.SelectedSet]=SCBISetNameEditBox:GetText()
	_G["SCBISet"..SkillChangerByIakoni.savedVariables.SelectedSet]:SetText(SCBISetNameEditBox:GetText())
end

function SkillChangerByIakoni.SaveSet()
	local s=SkillChangerByIakoni.savedVariables.SelectedSet
	local a=SkillChangerByIakoni.savedVariables.ArraySet
	local t=SkillChangerByIakoni.savedVariables.ArraySetTexture

	local activeWeaponPair = GetActiveWeaponPairInfo()
	local weaponset = 0
	local arraytouse = 0
	local counter = 1
	
	if (activeWeaponPair == ACTIVE_WEAPON_PAIR_MAIN) then
		arraytouse=SkillChangerByIakoni.SavedBarArray1
		weaponset = 1
	elseif (activeWeaponPair == ACTIVE_WEAPON_PAIR_BACKUP) then
		arraytouse=SkillChangerByIakoni.SavedBarArray2
		weaponset = 2
		counter = counter + 6
	end
	
	--loop through GetSlotBoundId(3-8), storing them in savedsetarray[1-6] or [7-12] depending on weaponbar 1 or 2
	for _,v in pairs(SkillChangerByIakoni.SkillBarArray) do
		local abilityID=GetSlotBoundId(v)
		local textureString=SkillChangerByIakoni.GetAbilityTexture(abilityID)
		a[s][counter]=abilityID
		if abilityID==0 then
			t[s][counter]=""
		else
			t[s][counter]=textureString
		end
		counter = counter + 1
	end
	
	SkillChangerByIakoni.UpdateSkillTexturesForSelected()

	SkillChangerByIakoni.savedVariables.ArraySetSavedFlag[s] = 1
	SkillChangerByIakoni.UpdateSavedFlags()
	
	d("Set " .. s .. " (Weaponbar "..weaponset..") saved.");
end

function SkillChangerByIakoni.EquipSet()
	if IsUnitInCombat("player") then
		d("Unable to swap sets in combat!")
		return
	end
	
	local s=SkillChangerByIakoni.savedVariables.SelectedSet
	local a=SkillChangerByIakoni.savedVariables.ArraySet
	
	if SkillChangerByIakoni.savedVariables.ArraySetSavedFlag[s] == 0 then
		d("Set " .. s .. " is empty.")
		return
	end
	
	local activeWeaponPair = GetActiveWeaponPairInfo()
	local weaponset = 0
	local counter = 1
	
	SkillChangerByIakoni.WaitingForSetToEquip = s
	if (activeWeaponPair == ACTIVE_WEAPON_PAIR_MAIN) then
		weaponset = 1
		SkillChangerByIakoni.WaitingForWeaponBarToEquip = ACTIVE_WEAPON_PAIR_BACKUP
	elseif (activeWeaponPair == ACTIVE_WEAPON_PAIR_BACKUP) then
		weaponset = 2
		SkillChangerByIakoni.WaitingForWeaponBarToEquip = ACTIVE_WEAPON_PAIR_MAIN
		counter = counter + 6
	end
	
	for _,v in pairs(SkillChangerByIakoni.SkillBarArray) do
		local skillAbilityId=GetSlotBoundId(v)
		if a[s][counter] ~= 0 and a[s][counter]~=skillAbilityId then
			local abilityIndex = SkillChangerByIakoni.GetAbilityId(a[s][counter])
			CallSecureProtected("SelectSlotAbility", abilityIndex, v)
		end
		counter = counter + 1
	end

	d("Set " .. s .. " (Weaponbar "..weaponset..") loaded.");
end

function SkillChangerByIakoni.ClearSet()
	local s=SkillChangerByIakoni.savedVariables.SelectedSet
	local a=SkillChangerByIakoni.savedVariables.ArraySet
	local t=SkillChangerByIakoni.savedVariables.ArraySetTexture

	--reset set icon and text
	SkillChangerByIakoni.savedVariables.ArraySetName[s] = s
	SkillChangerByIakoni.savedVariables.ArraySetIcon[s] = 1
	
	local y = SkillChangerByIakoni.TextureArrayForSet[1]
	_G["SCBISet"..s]:SetNormalTexture(y)
	_G["SCBISet"..s]:SetPressedTexture(y)
	_G["SCBISet"..s]:SetMouseOverTexture(y)	
  	_G["SCBISet"..s]:SetText(SkillChangerByIakoni.savedVariables.ArraySetName[s])
	SCBISetNameEditBox:SetText(SkillChangerByIakoni.savedVariables.ArraySetName[s]);
	
	--reset saved slots
	for _,v in pairs(SkillChangerByIakoni.SavedBarArray1) do
		t[s][v] = ""
		a[s][v] = 0
	end
	for _,v in pairs(SkillChangerByIakoni.SavedBarArray2) do
		t[s][v] = ""
		a[s][v] = 0
	end

	SkillChangerByIakoni.savedVariables.ArraySetSavedFlag[s] = 0
	SkillChangerByIakoni.UpdateSavedFlags()
	
	SkillChangerByIakoni.UpdateSkillTexturesForSelected()
	
	--[[
	for _,v in pairs(SkillChangerByIakoni.SkillBarArray) do
		CallSecureProtected("ClearSlot", v)
	end
	--]]
	
	d("Set " .. s .. " cleared.")
end

function SkillChangerByIakoni.ChangeNextIcon()
	local sv = SkillChangerByIakoni.savedVariables

	if sv.ArraySetIcon[sv.SelectedSet] + 1 > SkillChangerByIakoni.TextureArrayForSetSize then
		sv.ArraySetIcon[sv.SelectedSet] = 1
	else
		sv.ArraySetIcon[sv.SelectedSet] = sv.ArraySetIcon[sv.SelectedSet] + 1
	end
	
	local s = SkillChangerByIakoni.TextureArrayForSet[sv.ArraySetIcon[sv.SelectedSet]]
	
	_G["SCBISet"..sv.SelectedSet]:SetNormalTexture(s)
	_G["SCBISet"..sv.SelectedSet]:SetPressedTexture(s)
	_G["SCBISet"..sv.SelectedSet]:SetMouseOverTexture(s)
end

function SkillChangerByIakoni.ChangePrevIcon()
	local sv = SkillChangerByIakoni.savedVariables
	
	if sv.ArraySetIcon[sv.SelectedSet] - 1 <= 0 then
		sv.ArraySetIcon[sv.SelectedSet] = SkillChangerByIakoni.TextureArrayForSetSize
	else
		sv.ArraySetIcon[sv.SelectedSet] = sv.ArraySetIcon[sv.SelectedSet] - 1
	end
	
	local s = SkillChangerByIakoni.TextureArrayForSet[sv.ArraySetIcon[sv.SelectedSet]]
	
	_G["SCBISet"..sv.SelectedSet]:SetNormalTexture(s)
	_G["SCBISet"..sv.SelectedSet]:SetPressedTexture(s)
	_G["SCBISet"..sv.SelectedSet]:SetMouseOverTexture(s)
end

function SkillChangerByIakoni.SaveEmptySlots()
end

function SkillChangerByIakoni.OnAddOnLoaded(event, addonName)
	if addonName == SkillChangerByIakoni.name then
		SkillChangerByIakoni.Initialize()
	end
end

function SkillChangerByIakoni.OnIndicatorMoveStop()
	SkillChangerByIakoni.savedVariables.left = SCBI:GetLeft()
	SkillChangerByIakoni.savedVariables.top = SCBI:GetTop()
end

function SkillChangerByIakoni.RestorePosition()
	local left = SkillChangerByIakoni.savedVariables.left
	local top = SkillChangerByIakoni.savedVariables.top

	SCBI:ClearAnchors()
	SCBI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top)
end

function SkillChangerByIakoni.InitTextureArrayForSet()
	SkillChangerByIakoni.TextureArrayForSetSize = 0
	SkillChangerByIakoni.TextureArrayForSet = {
		"esoui/art/tutorial/gearslot_quickslot.dds",
		"esoui/art/tutorial/gearslot_neck.dds",
		"esoui/art/tutorial/gearslot_costume.dds",
		"esoui/art/tutorial/gearslot_feet.dds",
		"esoui/art/tutorial/gearslot_hands.dds",
		"esoui/art/tutorial/gearslot_head.dds",
		"esoui/art/characterwindow/gearslot_chest.dds",
		"esoui/art/tutorial/gearslot_legs.dds",
		"esoui/art/tutorial/gearslot_mainhand.dds",
		"esoui/art/tutorial/gearslot_offhand.dds",
		"esoui/art/tutorial/gearslot_shoulders.dds",
		"esoui/art/tutorial/gearslot_ring.dds",
	}
	
	for _,v in pairs(SkillChangerByIakoni.TextureArrayForSet) do
		if v ~= nil then
			SkillChangerByIakoni.TextureArrayForSetSize = SkillChangerByIakoni.TextureArrayForSetSize + 1
		end
	end
end

function SkillChangerByIakoni.OnWeaponLockChanged(eventCode, locked)
	if (locked == false) then
		SkillChangerByIakoni.DoEquipQueue()
	end
end

function SkillChangerByIakoni.HotkeyEquip(k)
	SkillChangerByIakoni.SelectSet(k)
	SkillChangerByIakoni.EquipSet()
end

function SkillChangerByIakoni.DoEquipQueue()
	if SkillChangerByIakoni.WaitingForSetToEquip == 0 or SkillChangerByIakoni.WaitingForWeaponBarToEquip == 0 then
		return
	end

	if IsUnitInCombat("player") then
		d("Unable to swap sets in combat!")
		return
	end
	
	--check if the weapon bar is queued for changing
	local activeWeaponPair = GetActiveWeaponPairInfo()
	if activeWeaponPair ~= SkillChangerByIakoni.WaitingForWeaponBarToEquip then
		return
	end
	
	local s=SkillChangerByIakoni.WaitingForSetToEquip
	local a=SkillChangerByIakoni.savedVariables.ArraySet
	
	--if set is somehow empty, return
	if SkillChangerByIakoni.savedVariables.ArraySetSavedFlag[s] == 0 then
		return
	end
	
	local weaponset = 0
	local counter = 1
	
	if (activeWeaponPair == ACTIVE_WEAPON_PAIR_MAIN) then
		weaponset = 1
	elseif (activeWeaponPair == ACTIVE_WEAPON_PAIR_BACKUP) then
		weaponset = 2
		counter = counter + 6
	end
	
	for _,v in pairs(SkillChangerByIakoni.SkillBarArray) do
		local skillAbilityId=GetSlotBoundId(v)
		if a[s][counter] ~= 0 and a[s][counter]~=skillAbilityId then
			local abilityIndex = SkillChangerByIakoni.GetAbilityId(a[s][counter])
			CallSecureProtected("SelectSlotAbility", abilityIndex, v)
		end
		counter = counter + 1
	end
	
	SkillChangerByIakoni.WaitingForSetToEquip = 0
	SkillChangerByIakoni.WaitingForWeaponBarToEquip = 0
	
	d("Set " .. s .. " (Weaponbar "..weaponset..") loaded.");
end

function SkillChangerByIakoni.GetAbilityId(skillId)
	local hasProgression, progressionIndex = GetAbilityProgressionXPInfoFromAbilityId(skillId) 
	local unMorphedName, morphChoice, rank = GetAbilityProgressionInfo(progressionIndex)
	local morphedName, texture, abilityIndex = GetAbilityProgressionAbilityInfo(progressionIndex, morphChoice, rank)
	return abilityIndex
end

function SkillChangerByIakoni.GetAbilityTexture(skillId)
	local hasProgression, progressionIndex = GetAbilityProgressionXPInfoFromAbilityId(skillId) 
	local unMorphedName, morphChoice, rank = GetAbilityProgressionInfo(progressionIndex)
	local morphedName, texture, abilityIndex = GetAbilityProgressionAbilityInfo(progressionIndex, morphChoice, rank)
	return texture
end

function SkillChangerByIakoni.UpdateSkillTexturesForSelected()
	local s=SkillChangerByIakoni.savedVariables.SelectedSet
	local t=SkillChangerByIakoni.savedVariables.ArraySetTexture
	
	for i=1,12 do
		if t[s][i] ~= nil and t[s][i] ~= "" then
			_G["SCBIPreview"..i]:SetTexture(t[s][i])
			_G["SCBIPreview"..i]:SetAlpha(1)
		else
			_G["SCBIPreview"..i]:SetTexture("")
			_G["SCBIPreview"..i]:SetAlpha(0)
		end
	end
end

EVENT_MANAGER:RegisterForEvent(SkillChangerByIakoni.name, EVENT_ADD_ON_LOADED, SkillChangerByIakoni.OnAddOnLoaded)
--EVENT_MANAGER:RegisterForEvent(SkillChangerByIakoni.name, EVENT_ACTIVE_WEAPON_PAIR_CHANGED, SkillChangerByIakoni.OnWeaponPairChanged)
EVENT_MANAGER:RegisterForEvent(SkillChangerByIakoni.name, EVENT_WEAPON_PAIR_LOCK_CHANGED, SkillChangerByIakoni.OnWeaponLockChanged)

ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP1", "Skill Set 1")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP2", "Skill Set 2")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP3", "Skill Set 3")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP4", "Skill Set 4")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP5", "Skill Set 5")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP6", "Skill Set 6")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP7", "Skill Set 7")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP8", "Skill Set 8")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP9", "Skill Set 9")
ZO_CreateStringId("SI_BINDING_NAME_SCBI_EQUIP10", "Skill Set 10")
